# Docker compose version (optional since v1.27.0)
version: '3.9'

# Services
services:

  # Service: server
  server:
    image: ${SERVER_IMAGE_NAME}
    build:
      context: ./server
      target: dev
    container_name: ${SERVER_CONTAINER_NAME}
    hostname: server
    ports:
      - "${SERVER_SSH_LOCAL_PORT}:${SERVER_SSH_CONTAINER_PORT}" # ssh port
      - "${SERVER_LARAVEL_LOCAL_PORT}:${SERVER_LARAVEL_CONTAINER_PORT}" # laravel server port (default: 8000)
    volumes:
      # IMPORTANT: `cached` or `delegated` mode is not supported in Windows environment
      # Only available in Linux or MacOS environment
      - ./server:/var/www/html:rw,cached
    command: "php artisan serve --host=0.0.0.0 --port=${SERVER_LARAVEL_CONTAINER_PORT}" # Run laravel server
    extra_hosts:
      - "host.docker.internal:host-gateway" # For xdebug -> see server/.docker/php/conf.d/xdebug.ini

  # Service: ui
  ui:
    image: ${UI_IMAGE_NAME}
    build:
      context: ./ui
      target: dev
    container_name: ${UI_CONTAINER_NAME}
    hostname: ui
    depends_on:
      - server # UI will be started AFTER server
    ports:
      - "${UI_SSH_LOCAL_PORT}:${UI_SSH_CONTAINER_PORT}" # ssh port
      - "${UI_NODE_LOCAL_PORT}:${UI_NODE_CONTAINER_PORT}" # webpack dev server port (default: 8080)
    volumes:
      # IMPORTANT: `cached` or `delegated` mode is not supported in Windows environment
      # Only available in Linux or MacOS environment
      - ./ui:/var/www/html:rw,cached
    command: "npm run serve -- --host=0.0.0.0 --port=${UI_NODE_CONTAINER_PORT}" # Run webpack dev server

# Networks
networks:
  default:
    name: ${NETWORK_NAME}

